MantisBT
Mantis Bug Tracker Workflow

View Issue Details Jump to Notes ] Related Changesets ] Issue History ] Print ]
IDProjectCategoryView StatusDate SubmittedLast Update
0023191Open CASCADE[OCCT] OCCT:Visualizationpublic2012-06-05 15:022014-11-11 12:57
Reporterkgv 
Assigned Tobugmaster 
PrioritynormalSeverityminor 
StatusclosedResolutionfixed 
PlatformOSOS Version
Product Version[OCCT] 6.5.3 
Target Version[OCCT] 6.8.0Fixed in Version[OCCT] 6.8.0 
Summary0023191: Visualization - small objects displayed with visual artifacts
DescriptionTrivial interactive object displayed with serious visual artifacts without sanity reason. The reason is probably very rude value used for Z-fit.
Steps To ReproduceOriginal test case:
pload VISUALIZATION MODELING
restore w:/irons.brep i
explode i
ttranslate i_1 0.005 0 0
vinit View1
vclear
vsetdispmode 1
vdisplay i i_1
vfit


Localized:
pload VISUALIZATION MODELING
restore w:/irons.brep i
explode i
explode i_2 F
compound i_2_1 i_2_4 i_2_5 i2
compound i_2_2 i_2_3       i3
ttranslate i_2 0.003 0 0
ttranslate i2  0.006 0 0
ttranslate i3  0.006 0 0
vinit View1
vclear
vsetdispmode 1
vdisplay i_2 i2 i3
vsetcolor i3 RED
vbottom
vfit
TagsNo tags attached.
Test case numberbugs vis(004) bug23191
Attached Filespng file icon wedges_compound.png (3,870 bytes) 2012-06-05 15:05
png file icon wedges_exploded.png (3,218 bytes) 2012-06-05 15:05
? file icon irons.brep (17,847 bytes) 2014-01-08 18:05
png file icon zart_671.png (2,518 bytes) 2014-07-09 14:30
png file icon zart_master.png (2,310 bytes) 2014-07-09 14:30

- Relationships
related to 0024539closedbugmaster Open CASCADE Visualization (new camera) - small objects displayed with visual artifacts 
related to 0024413closedabv Open CASCADE Visualization - get rid of projection shift from orthographic camera definition 
related to 0024521closedbugmaster Open CASCADE Visualization - automatic back face culling is not turned on for Solids packed into compound 

-  Notes
(0026254)
kgv (developer)
2013-10-24 13:18

Original shapes have been lost - should be re-created.
(0027401)
kgv (developer)
2014-01-09 08:53

The actual artifacts caused by rough Z fit range computation - should be checked on #0024001 branch.

The difference between compound / not compound is caused by back face culling mechanism which is turned on automatically for closed shapes. However mechanism is incomplete and works only when root shape has closed flag, see StdPrs_ShadedShape, ShadeFromShape():
    if (!theDrawer->ShadingAspectGlobal())
    {
      Handle(Graphic3d_AspectFillArea3d) anAsp = theDrawer->ShadingAspect()->Aspect();
      if (StdPrs_ToolShadedShape::IsClosed (theShape))
      {
        anAsp->SuppressBackFace();
      }
      else
      {
        anAsp->AllowBackFace();
      }

thus this check fails when closed shapes are stored in compound, or if displayed Solid without closed flag (for example - command "box" produces Solid without Closed flag, which contains Shell with Closed flag).
(0027402)
kgv (developer)
2014-01-09 08:58

Apart from z-fighting artifacts elimination (between back/front faces, noticeable on solid boundaries), back face culling affects performance as well.

Testing on Solid with 710784 triangles. Without culling:
FPS: 14.781480904813739
CPU: 14.664094000000034 msec

with culling:
FPS: 24.5940756343402
CPU: 9.6720619999999258 msec
(0027424)
kgv (developer)
2014-01-09 17:40

Behavior becomes worse on current patch for #0024001 issue.
(0030031)
kgv (developer)
2014-07-09 14:29

Dear bugmaster,

the original problem seems to be resolved by 0024413.
Please add localized test case to data base and switch to tested.
(0030193)
git (administrator)
2014-07-16 14:23

Branch CR23191 has been created by mkv.

SHA-1: 7ed22e71e0aff451947ec413b883a88ba7dcb781
(0030196)
git (administrator)
2014-07-16 15:09

Branch CR23191 has been updated by mkv.

SHA-1: 99d754d41ddfc801b16c31212f0117c0dc23067d
(0030199)
mkv (tester)
2014-07-16 15:16

Dear BugMaster,

Test case bugs/vis(004)/bug23191 was pushed to new branch CR23191 in occt git-repository.
SHA-1: 99d754d41ddfc801b16c31212f0117c0dc23067d
(0030448)
git (administrator)
2014-07-28 16:42

Branch CR23191 has been deleted by inv.

SHA-1: 99d754d41ddfc801b16c31212f0117c0dc23067d

- Related Changesets
occt: master 7d7ddef3
Timestamp: 2014-07-16 11:08:44
Author: mkv
Committer: bugmaster
Details ] Diff ]
0023191: Visualization - small objects displayed with visual artifacts

Test case for issue CR23191
add - tests/bugs/vis/bug23191 Diff ] File ]

- Issue History
Date Modified Username Field Change
2012-06-05 15:02 kgv New Issue
2012-06-05 15:02 kgv Assigned To => san
2012-06-05 15:05 kgv File Added: wedges_compound.png
2012-06-05 15:05 kgv File Added: wedges_exploded.png
2012-10-21 10:55 abv Target Version 6.5.4 => 6.6.0
2013-02-26 18:45 san Target Version 6.6.0 => 6.7.0
2013-10-24 13:18 kgv Note Added: 0026254
2013-10-24 13:18 kgv Assigned To san => kgv
2013-10-24 13:18 kgv Status new => feedback
2013-10-24 13:18 kgv Target Version 6.7.0 => 6.7.1
2014-01-08 18:05 kgv File Added: irons.brep
2014-01-08 18:06 kgv Steps to Reproduce Updated View Revisions
2014-01-08 18:06 kgv Status feedback => assigned
2014-01-09 08:46 kgv Relationship added related to 0024001
2014-01-09 08:53 kgv Note Added: 0027401
2014-01-09 08:58 kgv Note Added: 0027402
2014-01-09 11:14 kgv Relationship added related to 0024521
2014-01-09 17:40 kgv Note Added: 0027424
2014-01-09 17:40 kgv Assigned To kgv => duv
2014-01-16 09:41 kgv Summary Wedges compound displayed with serious visual artifacts => Visualization - small objects displayed with visual artifacts
2014-01-20 09:55 kgv Relationship added related to 0024539
2014-04-04 18:16 abv Target Version 6.7.1 => 6.8.0
2014-07-09 14:29 kgv Note Added: 0030031
2014-07-09 14:29 kgv Assigned To duv => bugmaster
2014-07-09 14:29 kgv Status assigned => feedback
2014-07-09 14:29 kgv Steps to Reproduce Updated View Revisions
2014-07-09 14:30 kgv File Added: zart_671.png
2014-07-09 14:30 kgv File Added: zart_master.png
2014-07-09 14:31 kgv Relationship added related to 0024413
2014-07-10 10:37 bugmaster Assigned To bugmaster => mkv
2014-07-16 14:23 git Note Added: 0030193
2014-07-16 15:09 git Note Added: 0030196
2014-07-16 15:16 mkv Note Added: 0030199
2014-07-16 15:17 mkv Test case number => bugs vis(004) bug23191
2014-07-16 15:17 mkv Assigned To mkv => bugmaster
2014-07-16 15:17 mkv Status feedback => tested
2014-07-25 14:45 bugmaster Changeset attached => occt master 7d7ddef3
2014-07-25 14:45 bugmaster Status tested => verified
2014-07-25 14:45 bugmaster Resolution open => fixed
2014-07-28 16:42 git Note Added: 0030448
2014-11-11 12:46 aiv Fixed in Version => 6.8.0
2014-11-11 12:57 aiv Status verified => closed


Copyright © 2000 - 2020 MantisBT Team
Powered by Mantis Bugtracker